<?php
/*
Plugin name: CP Tent Posts Shortcode
Plugin URI: https://brooks.tent.is/posts/pewx4u
Description: Shortcode returns a list of recent public posts
Version: 0.0.1
Author: Brooks
Author URI: http://brooks.tent.is
*/
function retrieve_public_tent_posts($tentserver = 'https://brooks.tent.is') {
	rtrim($tentserver, '/');
	//if(substr($tentserver, 0, 8)!='https://' || substr($tentserver, 0, 7)!='http://'):
	//	$tentserver .= '/tent'
	//endif;
	if(substr($tentserver, -8)=='.tent.is'):
		$tentserver .= '/tent';
	endif;

$tpwparameters = array('method'=>'GET','timeout'=>'5','redirection'=>'5','httpversion'=>'1.1','blocking'=>'true','headers'=>array('Content-Length: 2'),'body'=>'null','cookies'=>array());//not using params right now

$tpwresponse = wp_remote_get($tentserver . '/posts');

$tpwresponsemessage = wp_remote_retrieve_body($tpwresponse);

$tpwresponsearray = json_decode($tpwresponsemessage, true);
$cp_tent_posts_array = array();
foreach($tpwresponsearray as $response_single_tent_post){
	if(array_key_exists('text', $response_single_tent_post['content'])):
		if(is_array($response_single_tent_post['mentions'])):
			$mentions = array();
			$gotmentions = $response_single_tent_post['mentions'];
			foreach($gotmentions as $amention){//mentions
				$mentions[] = $amention['entity'];
			}//mentions
		endif;
		$thiscppost = array('text'=>$response_single_tent_post['content']['text'],'mentions'=>$mentions);
		$cptentpostid = $response_single_tent_post['id'];
		$cp_tent_posts_array[$cptentpostid] = $response_single_tent_post['content'];
	endif;
}
return $cp_tent_posts_array;
}//function

//adding shortcode
function cp_tent_public_posts_shortcode( $atts ) {
	extract(shortcode_atts(array('tent'=>'https://brooks.tent.is', 'limit'=>10), $atts));
	//echo $tent;
	$tentcounter=0;
	echo '<ul class="cptent">';
	foreach(retrieve_public_tent_posts($tent) as $acptentpost){
		if($tentcounter == $limit):
		break;
		endif;
	   echo '<li>';
	   echo $acptentpost['text'];
	   //if(is_array($acptentpost['mentions'])):
	   //print_r($acptentpost['mentions']);
	   /*
		   echo '
		   <br />
		   ';
		   echo '<span class="cptentmentions">mentions: ';
		   
		   foreach($acptentpost['mentions'] as $acpmention){
			   echo $acpmention . ' ';
		   }
		   echo '</span>';
	  // endif;
	  */
	   echo '</li>
	   ';
	   $tentcounter++;
   }
   echo '</ul>';
}
add_shortcode( 'cp-tent', 'cp_tent_public_posts_shortcode' );

add_action('wp_enqueue_scripts','cp_tent_stylesheet');
function cp_tent_stylesheet() {
	wp_register_style( 'cp-tent-style', plugins_url('style.css', __FILE__) );
	wp_enqueue_style( 'cp-tent-style' );
}

?>